; ******************************************************************************************************************
; **  REALIZADO POR FADISHOP  Tarjeta: FADIBUS  	http://www.fadishop.eu	FADITECO, S.L.U. 	Lleonard Garcia	**
; **  ESTE PROGRAMA VA INCREMENTANDO  CADA SEGUNDO EL PUERTO_1(LSB) Y EL PUERTO_0(MSB)					**
; ** 	LA DIRECCIN DEL SLAVE I2C ES $42 						SW2(A=0, B=0, C=1)				**
; **  											SW1(I0=0, I1=0, I2=0, portC=0,  Rpullup=0)** 
; **												JP9(no afecta JUMPER AZUL)			**
; **  																		**
; ******************************************************************************************************************
; CONFIGURACIONES
#picaxe 28x2		
let dirsB=%10000000	; 1=salida 0=entrada
let dirsC=%00000000	; 1=salida 0=entrada
; C.3 I2C_SCL
; C.4 I2C_SDA
;adcsetup = %00000000 	' CONFIGURACIN ENTRADAS ANALGICAS
;setfreq em16		; Resonador/oscilador externo a 16Mhz.

device_PCA9555N:						;DIRECCIONES INTERNAS DEL EXPANSOR DE BUS PCA9555N
symbol inport_0 = 0					; lectura de entradas del puerto_0
symbol inport_1 = 1					; lectura de entradas del puerto_1
symbol outport_0 = 2					; escritura en salidas del puerto_0.
symbol outport_1 = 3					; escritura en salidas del puerto_1.
symbol polaritat_port_0 = 4				; Pollaridad entradas puerto_0 --> 0=no_invertido, 1=invertido.
symbol polaritat_port_1 = 5				; Pollaridad entradas puerto_1 --> 0=no_invertido, 1=invertido.
symbol config_port_0 = 6				; configura puerto_0 como entrada o salida 1=entrada 0=salida.
symbol config_port_1 = 7				; configura puerto_1 como entrada o salida 1=entrada 0=salida.	
config_PCA9555N_A:					;CONFIGURACIN DEL DEVICE_A (A,B,C,D,E,F,G,H. Mximo 8)
symbol adress_slave_A =$42				; Direccin I2C del PCA9555N % 0100ABC(rw) ;SLAVE  PCA9555N (0X4E-0X4F)
symbol polport0_A = %00000000				; polaridad de las entradas del puerto_0: 0-sin inversi 1-invertidas
symbol polport1_A = %00000000				; polaridad de las entradas del puerto_1: 0-sin inversi 1-invertidas
symbol confport0_A = %00000000			; configuracin puerto_0 1=entrada 0=salida.
symbol confport1_A = %00000000			; configuracin puerto_1 1=entrada 0=salida.
transfer_config_PCA9555N_A:				;TRANSFERIR TODA LA CONFIGURACIN AL DEVICE_A
i2cslave adress_slave_A, i2cslow, i2cbyte		; envia/llamada a direccin del perifrico/slave.
writei2c polaritat_port_0,(polport0_A,polport1_A); envia polaridad de las entradas del puerto_0 y puerto_1
writei2c config_port_0,(confport0_A,confport1_A); envia configuracin del puerto_0 y puerto_1.
lectura_inicial_debug_A:				;LECTURA DE LOS REGISTROS INTERNOS DEL DEVICE_A
i2cslave adress_slave_A, i2cslow, i2cbyte		; Direccin I2C del PCA9555N % 0100ABC(rw) ;SLAVE  PCA9555N (0X4E-0X4F)
readi2c inport_0,(b0,b1)				; lectura entradas
readi2c outport_0,(b2,b3)				; lectura del registro de las salidas
readi2c polaritat_port_0,(b4,b5)			; lectura de la polaridad de las entradas.
readi2c config_port_0,(b6,b7)				; lectura de la configuracin de los puertos.
; INICIO
; DEFINICIONES Y INICIALIZACIONES
symbol cuenta_lsb=b16					; El registro RAM b16 se llamar "cuenta_lsb"
symbol cuenta_msb=b17					; El registro RAM b17 se llamar "cuenta_msb"
let	cuenta_lsb=0					; El registro "cuenta_lsb" inicialmente vale $00.
let	cuenta_msb=0					; El registro "cuenta_msb" inicialmente vale $00.
main:								; PROGRAMA CCLICO.
i2cslave adress_slave_A, i2cslow, i2cbyte		; Direcciona el Device/slave_A
writei2c outport_0,(cuenta_msb,cuenta_lsb)	; Escribe: cuenta_msb -->puerto_0 y cuenta_lsb -->puerto_1
pause 100							; Espera 0'1 segundo
debug								; Saca por una ventana emergente todos los registros.Aande retardo..
if cuenta_lsb=255 then inc cuenta_msb		; (SI) Incrementa la parte alta.
		  	     let cuenta_lsb=0		; (SI) Pone a 0 la parte baja.
			else inc cuenta_lsb		; (NO) Incrementa el registro "cuenta_lsb"		;
endif								;
goto main							; volver a empezar.